=== debian/changelog ===
rocm-hipamd (5.7.1-7) unstable; urgency=medium

  * Add d/p/0041-inline-bf16-functions.patch to mark functions defined
    in amd_hip_bf16.h as inline. This change prevents multiple
    definition errors during linking for programs that include
    <hip/hip_bf16.h> in more than one translation unit (Closes: #1116585)
  * Fix hipcc manpage title (Closes: #1107681)
  * Fix spelling error in roc-obj-ls manpage

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 04 Oct 2025 02:33:54 -0600

rocm-hipamd (5.7.1-6) unstable; urgency=medium

  * Revert "tests: allow deprecation warnings via allow-stderr restriction"
  * d/p/0031-find-package-minimum-policy.patch: raise max policy version
    in CMake config files to 3.31 to prevent deprecation warnings
    from find_package(hip) or enable_language(hip)
  * Remove the broken hiprtc::hiprtc imported target (Closes: #1088540)
  * d/control: libamdhip64-dev now suggests hipcc, which is required for
    HIP language support (Closes: #1094763)
  * Add d/p/0038-fix-FindHIP-search-for-HIP_CLANG_PATH.patch to prevent
    FindHIP.cmake from choosing an incorrect HIP_CLANG_PATH when ROCM_PATH
    or HIP_PATH are set (Closes: #1099404)
  * Add d/p/0039-fix-roc-obj-help.patch to fix garbage output in
    roc-obj-ls --help and roc-obj-extract --help (Closes: #1103558)
  * Add d/p/0040-self-sufficient-bf16-header.patch to fix undeclared
    identifier '__ockl_sdot2' errors in translation units that include
    hip_bf16.h before other headers (Closes: #1099402)
  * Add manpages for hipcc, hipconfig, roc-obj, roc-obj-ls, and roc-obj-extract
    (Closes: #1103689)

  [ Helmut Grohne ]
  * Mark libamdhip64-5, libhiprtc-builtins5, and rocm-opencl-icd
    Multi-Arch: same (Closes: #1086329)

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 13 May 2025 05:50:23 -0600

rocm-hipamd (5.7.1-5.1) unstable; urgency=medium

  * Non-maintainer upload
  * tests: allow deprecation warnings via allow-stderr restriction
    (Closes: #1087869)

 -- Paul Gevers <elbrus@debian.org>  Sat, 12 Apr 2025 12:51:52 +0200

rocm-hipamd (5.7.1-5) unstable; urgency=medium

  * Source only upload for migration to testing.
  * Update Standards-Version to 4.7.0. No changes required.
  * Add d/rocm-opencl-icd.install to fix FTBFS in some configurations.
  * Add d/rocm-opencl-icd.triggers to fix lacks-ldconfig-trigger
    (Closes: #1082715)

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 24 Sep 2024 16:15:52 -0600

rocm-hipamd (5.7.1-4) unstable; urgency=medium

  * Enable OpenCL in rocm-opencl-icd.  Set Breaks on mesa-opencl-icd and
    pocl-opencl-icd since having either causes an LLVM load error.

 -- Kari Pahula <kaol@debian.org>  Tue, 02 Jul 2024 12:22:54 +0300

rocm-hipamd (5.7.1-3) unstable; urgency=medium

  * Add d/p/0035-optional-device-libs-find-package.patch to make
    rocm-device-libs-17 an optional dependency in hip-config.cmake.
  * Add d/p/0036-fix-clangrt-check-for-c.patch to provide consistent
    status information from hip-config.cmake about compiler-rt when
    configuring C and C++ projects.
  * Add d/p/0037-deduplicate-cmake-messages.patch to reduce the verbosity
    of hip-config.cmake.

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 26 Mar 2024 00:42:03 -0600

rocm-hipamd (5.7.1-2) unstable; urgency=medium

  * Add d/p/0034-default-to-hip-platform-amd.patch to have hip-config.cmake
    default to building for the AMD platform if hipconfig is not available.
  * d/gbp.conf: ensure use of pristine-tar
  * d/t/hipconfig: enable hipconfig autopkgtests even if KFD is not available
  * d/control: drop dpkg-dev from hipcc depends because it is no longer used
  * d/t/control: require rocminfo (>= 5.7.1~) in autopkgtests to fix failures
    on systems without AMD GPUs

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 20 Mar 2024 01:57:15 -0600

rocm-hipamd (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 07 Mar 2024 10:57:55 -0700

rocm-hipamd (5.7.1-1~exp2) experimental; urgency=medium

  * Fix FTBFS on arm64 by conditionally removing use of SSE intrinsics.
  * Fix gcc, clang and g++ autopkgtests.
  * Add d/p/0033-fix-hipconfig-version-githash.patch to fix hipconfig
    version number.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 03 Mar 2024 17:31:02 -0700

rocm-hipamd (5.7.1-1~exp1) experimental; urgency=medium

  * New upstream version 5.7.1
  * Update URLs to reflect consolidation of hipamd, rocclr and
    rocm-opencl into clr.
  * Enable hardening flags.
  * d/libamdhip64-5.symbols: mark hipRegisterTracerCallback as an
    optional symbol. This function is not found in any public header.
    It is an unstable internal interface used by ROCm profiling tools.
  * d/libhiprtc-builtins.so.5: fix lintian warning
    symbols-file-missing-build-depends-package-field
  * Add d/p/0030-disable-immintrin-on-ppc64el.patch to fix build
    on ppc64el.
  * Add d/p/0031-find-package-minimum-policy.patch to fix CMake
    policy warning in find_package(hip).
  * Expand autopkgtests with more build checks (no GPU required).
  * Add d/p/0032-hipcc-compiler-launcher.patch to provide
    HIP_CLANG_LAUNCHER environment variable in hipcc.
    Thanks to Gavin Zhao.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 03 Mar 2024 00:21:39 -0700

rocm-hipamd (5.6.1-1~exp1) experimental; urgency=medium

  * New upstream version 5.6.1
  * Add hipcc upstream tarball
  * Update upstream URLs
  * Update from clang-15 to clang-17 (Closes: #1061208)
  * d/control: drop mlir from build-depends
  * d/control: add graphviz to doc build dependencies (Closes: 1064721)
  * d/rules: disable build tests
  * d/rules: disable rpath rather than patching it out
  * d/hipcc.install: drop install of hip_embed_pch.sh
  * d/libamdhip64-5.symbols: mark profiling API symbols as optional

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 27 Feb 2024 02:38:42 -0700

rocm-hipamd (5.2.3-13) unstable; urgency=medium

  * Add debian/clean (Closes: #1046076)

 -- Christian Kastner <ckk@debian.org>  Thu, 14 Sep 2023 15:48:26 +0200


